	AREA wram_code2, CODE, READWRITE

	INCLUDE equates.h
	INCLUDE 6502.h

	EXPORT void
	EXPORT empty_R
	EXPORT empty_W
	EXPORT ram_R
	EXPORT ram_W
	EXPORT sram_R
	EXPORT sram_W
	EXPORT rom_R
	EXPORT filler_
;----------------------------------------------------------------------------
empty_R		;read bad address (error)
;----------------------------------------------------------------------------
void ;- - - - - - - - -empty function
	mov r0,#0	;VS excitebike likes this
empty_W
	mov pc,lr
;----------------------------------------------------------------------------
ram_R	;ram read ($0000-$1FFF)
;----------------------------------------------------------------------------
	bic addy,addy,#0xf800
	ldrb r0,[nes_zpage,addy]
	mov pc,lr
;----------------------------------------------------------------------------
ram_W	;ram write ($0000-$1FFF)
;----------------------------------------------------------------------------
	bic addy,addy,#0xf800
	strb r0,[nes_zpage,addy]
	mov pc,lr
;----------------------------------------------------------------------------
sram_R	;sram read ($6000-$7FFF)
;----------------------------------------------------------------------------
	sub r1,addy,#0x5800
	ldrb r0,[nes_zpage,r1]
	mov pc,lr
;----------------------------------------------------------------------------
sram_W	;sram write ($6000-$7FFF)
;----------------------------------------------------------------------------
	sub addy,addy,#0x5800
	strb r0,[nes_zpage,addy]
	mov pc,lr
;----------------------------------------------------------------------------
rom_R	;rom read ($8000-$FFFF)
;----------------------------------------------------------------------------
	adr r2,memmap_tbl
	ldr r1,[r2,r1,lsl#2] ;r1=addy>>13
	ldrb r0,[r1,addy]
	mov pc,lr
;----------------------------------------------------------------------------
 AREA rom_code, CODE, READONLY
filler_ ;r0=data r1=dest r2=word count
;	exit with r0 unchanged
;----------------------------------------------------------------------------
	subs r2,r2,#1
	str r0,[r1,r2,lsl#2]
	bne filler_
	mov pc,lr
;----------------------------------------------------------------------------
	END
