	INCLUDE equates.h
	INCLUDE memory.h
	INCLUDE 6502mac.h
	INCLUDE 6502.h
	INCLUDE io.h

	IMPORT findrom ;from main.c
	IMPORT mapper666init

	EXPORT loadcart
	EXPORT hflags
	EXPORT romstart
	EXPORT romnum
;----------------------------------------------------------------------------
 AREA rom_code, CODE, READONLY
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
loadcart ;called from C:  r0=rom number, r1=hackflags
;----------------------------------------------------------------------------
	stmfd sp!,{r0-r1,r4-r11,lr}

	bl findrom		;r0 now points to rom image (including header)

	ldr globalptr,=|wram_globals0$$Base|	;need ptr regs init'd
	ldr nes_zpage,=NES_RAM

	mov r3,r0
	str r3,rombase		;set rom base
				;r3=rombase til end of loadcart so DON'T FUCK IT UP
	ldmfd sp!,{r0-r1}
	str r0,romnumber
	str r1,hackflags

	mov r0,#-1
	str r0,rommask		;rommask=romsize-1

	mov r1,#0
	strb r1,cartflags	;set cartflags

	mov r0,#0		;clear nes ram+sram
	mov r1,nes_zpage
	mov r2,#0x2800/4
	bl filler_

	mov nes_pc,#0	;(eliminates any encodePC errors during mapper*init)
	str nes_pc,lastbank

	bl mapper666init
0
	bl nes_reset		;reset everything else
	ldmfd sp!,{r4-r11,pc}
;----------------------------------------------------------------------------
 AREA wram_globals2, CODE, READWRITE

romstart
	DCD 0 ;rombase
romnum
	DCD 0 ;romnumber
rominfo			;keep hackflags/BGmirror together for savestate/loadstate
hflags	DCD SCALESPRITES ;hackflags	(label this so UI.C can take a peek) see equates.h for bitfields
	DCD 0 ;BGmirror		(BG size for BG0CNT)

	DCD 0 ;rommask
	DCD 0 ;vrombase
	DCD 0 ;vrommask
	DCD 0 ;sram_slot

	DCB 0 ;cartflags
;----------------------------------------------------------------------------
	END
