#include <stdio.h>
#include <string.h>
#include "gba.h"

extern u32 hflags;	//from cart.s
extern u32 joycfg;	//from io.s
extern u32 font;
extern u32 fontpal;
extern volatile u32 agb_vbl;	//6502.s

//asm calls
void loadcart(int,int);	//from cart.s
void run(int);
void ppu_init(void);
void resetSIO(u32);//io.s
void nsfreset(void);
void nsfinit(int);
void nsfplay(void);

void doReset(void);

const unsigned __fp_status_arm=0x40070000;
u8 *textstart;//where rom descriptions reside (initialized by boot.s)
#define SONGS *(u8*)0x2015006

void C_entry() {
	int lastsong;
	int joypad,lastjoy,key;
	int currentsong=0;
	int count=0;

	textstart=(*(u8**)0x0203FBFC);
	ppu_init();

	loadcart(0,0);

	lastsong=(SONGS)-1;
	nsfreset();
	nsfinit(currentsong);

	lastjoy=joypad=REG_P1^0x3ff;
	while(1) {
		count++;
		joypad=REG_P1^0x3ff;
		lastjoy=lastjoy^joypad;
		key=lastjoy&joypad;
		lastjoy=joypad;

		if(key&RIGHT) {
			if(currentsong<lastsong)
				currentsong++;
			else
				currentsong=0;
			nsfinit(currentsong);
		}
		if(key&LEFT) {
			if(currentsong)
				currentsong--;
			else
				currentsong=lastsong;
			nsfinit(currentsong);
		}
		if(key&(START|B_BTN))
			doReset();
		if(joypad&UP) {
			nsfplay();
		}
		if(!(joypad&DOWN) || (count&1))
			nsfplay();
		while(!agb_vbl);
		agb_vbl=0;
	}
}

u8* findrom() {
	return textstart;
}