	INCLUDE equates.h
	INCLUDE memory.h
	INCLUDE 6502.h
	INCLUDE 6502mac.h
	INCLUDE io.h

	EXPORT mapper666init

 AREA rom_code, CODE, READONLY ;-- - - - - - - - - - - - - - - - - - - - - -
nsf_rom
	INCBIN nsfrom.bin

	AREA wram_code3, CODE, READWRITE

RAMBASE EQU 0x2010000

;----------------------------------------------------------------------------
nsfram_R	;ram read ($8000-$FFFF)
;----------------------------------------------------------------------------
	ldr r1,=RAMBASE
	ldrb r0,[addy,r1]
	mov pc,lr
;----------------------------------------------------------------------------
lo_nsfram_R	;ram read
;----------------------------------------------------------------------------
	cmp addy,#0x5000
	blo IO_R

	ldr r1,=RAMBASE
	ldrb r0,[addy,r1]
	mov pc,lr
;----------------------------------------------------------------------------
mapper666init
;----------------------------------------------------------------------------

	ldr r0,=RAMBASE
	str r0,memmap_tbl+8		;4000-5fff
	str r0,memmap_tbl+16		;map $8000-FFFF to ram
	str r0,memmap_tbl+20
	str r0,memmap_tbl+24
	str r0,memmap_tbl+28

	adr r0,lo_nsfram_R
	str r0,readmem_tbl+8
	adr r0,nsfram_R
	str r0,readmem_tbl+16
	str r0,readmem_tbl+20
	str r0,readmem_tbl+24
	str r0,readmem_tbl+28

	adr r1,w4000
	str r1,writemem_tbl+8

	ldr r0,rombase			;copy nsf header to 5000
	ldr r1,=RAMBASE+0x5000
i0	ldrb r2,[r0],#1
	strb r2,[r1],#1
	tst r1,#0x80
	beq i0

	str r0,rombase	;rombase+=$80

	ldr r0,=nsf_rom			;copy nsf player to 5080
i1	ldrb r2,[r0],#1
	strb r2,[r1],#1
	tst r1,#0x400
	beq i1
					;setup bankswitch data if missing
	ldr r0,=RAMBASE+0x5000
	ldrh r3,[r0,#8]		;load addr
	ldr r1,[r0,#0x70]
	ldr r2,[r0,#0x74]
	orrs r1,r1,r2
	bicne r3,r3,#0xf000
	bne mi0

	ldr r1,=0x03020100
	str r1,[r0,#0x70]
	ldr r1,=0x007060504
	str r1,[r0,#0x74]

	bic r3,r3,#0x8000
mi0
	ldr r2,rombase
	sub r2,r2,r3
	str r2,rombase

        mov pc,lr
;----------------------------------------------------------------------------
w4000
;----------------------------------------------------------------------------
	cmp addy,#0x5f00
	blo IO_W

	and addy,addy,#7
	ldr r1,=RAMBASE+0x8000
	add addy,r1,addy,lsl#12

	and r0,r0,#0xff
	ldr r1,rombase
	add r1,r1,r0,lsl#12

	ldr r2,=0xfff
blah	ldrb r0,[r1],#1
	strb r0,[addy],#1
	tst addy,r2
	bne blah


	mov pc,lr
;----------------------------------------------------------------------------
        END
