	INCLUDE equates.h
	INCLUDE memory.h
	INCLUDE io.h
	INCLUDE 6502.h
	INCLUDE sound.h

	EXPORT ppu_init

 AREA rom_code, CODE, READONLY
;----------------------------------------------------------------------------
ppu_init	;(called from main.c) only need to call once
;----------------------------------------------------------------------------
	mov addy,lr

	ldr r1,=AGB_IRQVECT
	ldr r2,=irqhandler
	str r2,[r1]

	mov r1,#REG_BASE
	mov r0,#0x0008
	strh r0,[r1,#REG_DISPSTAT]	;vblank en

	add r2,r1,#REG_IE
	mov r0,#-1
	strh r0,[r2,#2]		;stop pending interrupts
	ldr r0,=0x0011
	strh r0,[r2]		;vblank,timer1 interrupt enable
	mov r0,#1
	strh r0,[r2,#8]		;master irq enable

	mov pc,addy
;----------------------------------------------------------------------------
	AREA wram_code1, CODE, READWRITE
irqhandler	;r0-r3,r12 are safe to use
;----------------------------------------------------------------------------
	mov r2,#REG_BASE
	ldr r1,[r2,#REG_IE]!
	strh r1,[r2,#2]		;IF clear
	and r1,r1,r1,lsr#16	;r1=IE&IF
	;---
	ands r0,r1,#0x10
	bne timer1interrupt
	ands r0,r1,#0x01
	bne vblankinterrupt
	;----
	bx lr
;----------------------------------------------------------------------------
vblankinterrupt;
;----------------------------------------------------------------------------
	strb r0,agb_vbl
	bx lr
;----------------------------------------------------------------------------
	END
